#include "httpd.h"
#include "http_config.h"
#include "http_protocol.h"
#include "ap_config.h"
#include <sys/types.h>

static int benchmark_handler(request_rec *r)
{
    int i;

    r->content_type = "text/html";      
    ap_send_http_header(r);

    ap_rputs("<html><body>\n<ol>\n", r);
    for (i = 0; i < 50; i++) {
        time_t t = time(NULL);
        char *date = ap_ht_time(r->pool, t, "%a %b %d %X %Z %Y", 0);
        ap_rprintf(r, "<li>%s</li>\n", date);
    }
    ap_rputs("</ol>\n</body></html>", r);
    return OK;
}

/* Dispatch list of content handlers */
static const handler_rec benchmark_handlers[] = { 
    { "benchmark", benchmark_handler }, 
    { NULL, NULL }
};

/* Dispatch list for API hooks */
module MODULE_VAR_EXPORT benchmark_module = {
    STANDARD_MODULE_STUFF, 
    NULL,                  /* module initializer                  */
    NULL,                  /* create per-dir    config structures */
    NULL,                  /* merge  per-dir    config structures */
    NULL,                  /* create per-server config structures */
    NULL,                  /* merge  per-server config structures */
    NULL,                  /* table of config file commands       */
    benchmark_handlers,       /* [#8] MIME-typed-dispatched handlers */
    NULL,                  /* [#1] URI to filename translation    */
    NULL,                  /* [#4] validate user id from request  */
    NULL,                  /* [#5] check if the user is ok _here_ */
    NULL,                  /* [#3] check access by host address   */
    NULL,                  /* [#6] determine MIME type            */
    NULL,                  /* [#7] pre-run fixups                 */
    NULL,                  /* [#9] log a transaction              */
    NULL,                  /* [#2] header parser                  */
    NULL,                  /* child_init                          */
    NULL,                  /* child_exit                          */
    NULL                   /* [#0] post read-request              */
};

