#include "httpd.h"
#include "http_config.h"
#include "http_protocol.h"
#include "ap_config.h"

#include "http_log.h"

/* The sample content handler */
static int conditional_request_handler(request_rec *r)
{
    struct stat finfo;
    int rc;  /* ꥯȤؤα */

    /* ǽ */
    if (stat("/tmp/mtime.txt", &finfo) < 0) {
        ap_log_rerror(APLOG_MARK, APLOG_ERR, r,
                      "file not found or unable to stat");
        return HTTP_FORBIDDEN;
    }
    ap_update_mtime(r, finfo.st_mtime);
    ap_set_last_modified(r);
    ap_set_etag(r);
    /* ꥯȤξȥƥĤξ֤ӤŬڤʱɤ֤
     * ap_meets_conditions֤ɤ
     * OK, HTTP_NOT_MODIFIED, HTTP_PRECONDITION_FAILEDΤ줫
     */
    rc = ap_meets_conditions(r);
    if (rc != OK) {
        return rc;
    }
	
    r->content_type = "text/html";      
    ap_send_http_header(r);
    if (!r->header_only)
        ap_rputs("The sample page from mod_conditional_request.c\n", r);
    return OK;
}

/* Dispatch list of content handlers */
static const handler_rec conditional_request_handlers[] = { 
    { "conditional_request", conditional_request_handler }, 
    { NULL, NULL }
};

/* Dispatch list for API hooks */
module MODULE_VAR_EXPORT conditional_request_module = {
    STANDARD_MODULE_STUFF, 
    NULL,                  /* module initializer                  */
    NULL,                  /* create per-dir    config structures */
    NULL,                  /* merge  per-dir    config structures */
    NULL,                  /* create per-server config structures */
    NULL,                  /* merge  per-server config structures */
    NULL,                  /* table of config file commands       */
    conditional_request_handlers,       /* [#8] MIME-typed-dispatched handlers */
    NULL,                  /* [#1] URI to filename translation    */
    NULL,                  /* [#4] validate user id from request  */
    NULL,                  /* [#5] check if the user is ok _here_ */
    NULL,                  /* [#3] check access by host address   */
    NULL,                  /* [#6] determine MIME type            */
    NULL,                  /* [#7] pre-run fixups                 */
    NULL,                  /* [#9] log a transaction              */
    NULL,                  /* [#2] header parser                  */
    NULL,                  /* child_init                          */
    NULL,                  /* child_exit                          */
    NULL                   /* [#0] post read-request              */
};

