/* 
**  mod_hello_apache2.c -- Apache sample hello_apache2 module
**  [Autogenerated via ``apxs -n hello_apache2 -g'']
**
**  To play with this sample module first compile it into a
**  DSO file and install it into Apache's modules directory 
**  by running:
**
**    $ apxs -c -i mod_hello_apache2.c
**
**  Then activate it in Apache's httpd.conf file for instance
**  for the URL /hello_apache2 in as follows:
**
**    #   httpd.conf
**    LoadModule hello_apache2_module modules/mod_hello_apache2.so
**    <Location /hello_apache2>
**    SetHandler hello_apache2
**    </Location>
**
**  Then after restarting Apache via
**
**    $ apachectl restart
**
**  you immediately can request the URL /hello_apache2 and watch for the
**  output of this module. This can be achieved for instance via:
**
**    $ lynx -mime_header http://localhost/hello_apache2 
**
**  The output should be similar to the following one:
**
**    HTTP/1.1 200 OK
**    Date: Tue, 31 Mar 1998 14:42:22 GMT
**    Server: Apache/1.3.4 (Unix)
**    Connection: close
**    Content-Type: text/html
**  
**    The sample page from mod_hello_apache2.c
*/ 

#include "httpd.h"
#include "http_config.h"
#include "http_protocol.h"
#include "ap_config.h"

/* The sample content handler */
static int hello_apache2_handler(request_rec *r)
{
    if (strcmp(r->handler, "hello_apache2")) {
        return DECLINED;
    }
    r->content_type = "text/html";      

    if (!r->header_only)
        ap_rputs("The sample page from mod_hello_apache2.c\n", r);
    return OK;
}

static void hello_apache2_register_hooks(apr_pool_t *p)
{
    ap_hook_handler(hello_apache2_handler, NULL, NULL, APR_HOOK_MIDDLE);
}

/* Dispatch list for API hooks */
module AP_MODULE_DECLARE_DATA hello_apache2_module = {
    STANDARD20_MODULE_STUFF, 
    NULL,                  /* create per-dir    config structures */
    NULL,                  /* merge  per-dir    config structures */
    NULL,                  /* create per-server config structures */
    NULL,                  /* merge  per-server config structures */
    NULL,                  /* table of config file commands       */
    hello_apache2_register_hooks  /* register hooks                      */
};

