#include "httpd.h"
#include "http_config.h"
#include "http_protocol.h"
#include "ap_config.h"

/* The sample content handler */
static int reqinfo_handler(request_rec *r)
{
    r->content_type = "text/html";      
    ap_send_http_header(r);
    if (r->header_only)
        return OK;

    ap_rputs("<html><body>\n", r);
    ap_rprintf(r, "URI: %s<br>\n",          r->uri);
    ap_rprintf(r, "Query String: %s<br>\n", r->args ? r->args : "");
    ap_rprintf(r, "Client Host: %s<br>\n",  r->connection->remote_ip);
    ap_rputs("</body></html>", r);

    return OK;
}

/* Dispatch list of content handlers */
static const handler_rec reqinfo_handlers[] = { 
    { "reqinfo", reqinfo_handler }, 
    { NULL, NULL }
};

/* Dispatch list for API hooks */
module MODULE_VAR_EXPORT reqinfo_module = {
    STANDARD_MODULE_STUFF, 
    NULL,                  /* module initializer                  */
    NULL,                  /* create per-dir    config structures */
    NULL,                  /* merge  per-dir    config structures */
    NULL,                  /* create per-server config structures */
    NULL,                  /* merge  per-server config structures */
    NULL,                  /* table of config file commands       */
    reqinfo_handlers,       /* [#8] MIME-typed-dispatched handlers */
    NULL,                  /* [#1] URI to filename translation    */
    NULL,                  /* [#4] validate user id from request  */
    NULL,                  /* [#5] check if the user is ok _here_ */
    NULL,                  /* [#3] check access by host address   */
    NULL,                  /* [#6] determine MIME type            */
    NULL,                  /* [#7] pre-run fixups                 */
    NULL,                  /* [#9] log a transaction              */
    NULL,                  /* [#2] header parser                  */
    NULL,                  /* child_init                          */
    NULL,                  /* child_exit                          */
    NULL                   /* [#0] post read-request              */
#ifdef EAPI
   ,NULL,                  /* EAPI: add_module                    */
    NULL,                  /* EAPI: remove_module                 */
    NULL,                  /* EAPI: rewrite_command               */
    NULL                   /* EAPI: new_connection                */
#endif
};

