#include "httpd.h"
#include "http_config.h"
#include "http_protocol.h"
#include "ap_config.h"
#include "http_core.h"

/* The sample content handler */
static int reqinfo_handler(request_rec *r)
{
    r->content_type = "text/html";      
    ap_send_http_header(r);
    if (r->header_only)
        return OK;

    ap_rputs("<html><body>\n", r);
    /* ꥯȤξ */
    ap_rprintf(r, "REQUEST_METHOD:   %s<br>\n", r->method);
    ap_rprintf(r, "QUERY_STRING:     %s<br>\n", r->args ? r->args : "");
    ap_rprintf(r, "SCRIPT_NAME:      %s<br>\n", r->uri);
    ap_rprintf(r, "PATH_INFO:        %s<br>\n",
               r->path_info ? r->path_info : "");
    ap_rprintf(r, "SCRIPT_FILENAME:  %s<br>\n", r->filename);
    /* ꥯȥإåξ */
    ap_rprintf(r, "HTTP_USER_AGENT:  %s<br>\n",
               ap_table_get(r->headers_in, "User-Agent") ?
               ap_table_get(r->headers_in, "User-Agent") : "");
    ap_rprintf(r, "HTTP_REFERER:     %s<br>\n",
               ap_table_get(r->headers_in, "Referer") ?
               ap_table_get(r->headers_in, "Referer") : "");
    /* Client/Server³ξ */
    ap_rprintf(r, "SERVER_ADDR:      %s<br>\n", r->connection->local_ip);
    ap_rprintf(r, "REMOTE_ADDR:      %s<br>\n", r->connection->remote_ip);
    ap_rprintf(r, "REMOTE_USER:      %s<br>\n",
               r->connection->user ? r->connection->user : "");
    /* Server */
    ap_rprintf(r, "DOCUMENT_ROOT:    %s<br>\n", ap_document_root(r));
    ap_rprintf(r, "SERVER_ADMIN:     %s<br>\n", r->server->server_admin);
    ap_rprintf(r, "SERVER_NAME:      %s<br>\n", ap_get_server_name(r));
    ap_rprintf(r, "SERVER_PORT:      %u<br>\n", ap_get_server_port(r));
    ap_rprintf(r, "SERVER_SOFTWARE:  %s<br>\n", ap_get_server_version());
    ap_rprintf(r, "SERVER_SIGNATURE: %s<br>\n", ap_psignature("", r));

    ap_rputs("</body></html>", r);

    return OK;
}

/* Dispatch list of content handlers */
static const handler_rec reqinfo_handlers[] = { 
    { "reqinfo", reqinfo_handler }, 
    { NULL, NULL }
};

/* Dispatch list for API hooks */
module MODULE_VAR_EXPORT reqinfo_module = {
    STANDARD_MODULE_STUFF, 
    NULL,                  /* module initializer                  */
    NULL,                  /* create per-dir    config structures */
    NULL,                  /* merge  per-dir    config structures */
    NULL,                  /* create per-server config structures */
    NULL,                  /* merge  per-server config structures */
    NULL,                  /* table of config file commands       */
    reqinfo_handlers,       /* [#8] MIME-typed-dispatched handlers */
    NULL,                  /* [#1] URI to filename translation    */
    NULL,                  /* [#4] validate user id from request  */
    NULL,                  /* [#5] check if the user is ok _here_ */
    NULL,                  /* [#3] check access by host address   */
    NULL,                  /* [#6] determine MIME type            */
    NULL,                  /* [#7] pre-run fixups                 */
    NULL,                  /* [#9] log a transaction              */
    NULL,                  /* [#2] header parser                  */
    NULL,                  /* child_init                          */
    NULL,                  /* child_exit                          */
    NULL                   /* [#0] post read-request              */
};

