#include "httpd.h"
#include "http_config.h"
#include "http_protocol.h"
#include "ap_config.h"
#include "libapreq/apache_cookie.h"

/* The sample content handler */
static int send_cookie_handler(request_rec *r)
{
    ApacheCookie *cookie;

    r->content_type = "text/html";
    cookie = ApacheCookie_new(r,
	                      "-name",    "message",
	                      "-value",   "Hello World",
	                      "-expires", "+3h",
                              NULL);
    /*
    ap_table_add(r->headers_out,
                 "Set-Cookie", ApacheCookie_as_string(cookie));
    */
    ApacheCookie_bake(cookie);
    ap_send_http_header(r);
    ap_rprintf(r, "Send HTTP Cookie now!");
    return OK;
}

/* Dispatch list of content handlers */
static const handler_rec send_cookie_handlers[] = { 
    { "send_cookie", send_cookie_handler }, 
    { NULL, NULL }
};

/* Dispatch list for API hooks */
module MODULE_VAR_EXPORT send_cookie_module = {
    STANDARD_MODULE_STUFF, 
    NULL,                  /* module initializer                  */
    NULL,                  /* create per-dir    config structures */
    NULL,                  /* merge  per-dir    config structures */
    NULL,                  /* create per-server config structures */
    NULL,                  /* merge  per-server config structures */
    NULL,                  /* table of config file commands       */
    send_cookie_handlers,       /* [#8] MIME-typed-dispatched handlers */
    NULL,                  /* [#1] URI to filename translation    */
    NULL,                  /* [#4] validate user id from request  */
    NULL,                  /* [#5] check if the user is ok _here_ */
    NULL,                  /* [#3] check access by host address   */
    NULL,                  /* [#6] determine MIME type            */
    NULL,                  /* [#7] pre-run fixups                 */
    NULL,                  /* [#9] log a transaction              */
    NULL,                  /* [#2] header parser                  */
    NULL,                  /* child_init                          */
    NULL,                  /* child_exit                          */
    NULL                   /* [#0] post read-request              */
#ifdef EAPI
   ,NULL,                  /* EAPI: add_module                    */
    NULL,                  /* EAPI: remove_module                 */
    NULL,                  /* EAPI: rewrite_command               */
    NULL                   /* EAPI: new_connection                */
#endif
};

