#include "httpd.h"
#include "http_config.h"
#include "http_protocol.h"
#include "ap_config.h"

module MODULE_VAR_EXPORT simple_conf_module;

typedef struct {
    char *message;
} simple_dir_config;

/* simple_conf⥸塼Υǥ쥯ȥ򥢥Ȥ */
static void *create_per_dir_config(pool *p, char *arg)
{
    simple_dir_config *conf;

    conf = ap_pcalloc(p, sizeof(simple_dir_config));
    conf->message = ap_pstrdup(p, "default");
    return (void *)conf;
}

/*
static void *merge_dir_config(pool *p, void *base_conf, void *sub_conf)
{
    simple_dir_config *base = base_conf;
    simple_dir_config *sub = sub_conf;

    if (strcmp(base->message, "default") == 0)
        return (void *)sub;
    else
        return (void *)base;
}
*/

/* SetMessageǥ쥯ƥ֤ꤵ줿ͤ */
static const char *cmd_set_message(cmd_parms *parms, void *mconfig, char *arg)
{
    simple_dir_config *conf;

    if (strlen(arg) > 256)
        return "message too long.";

    conf = mconfig;
    conf->message = ap_pstrdup(parms->pool, arg);
    return NULL;
}


static const command_rec cmds[] =
{
    {
         "SetMessage",    /* ǥ쥯ƥ֤̾                   */
         cmd_set_message, /* 򤪤ʤؿΥݥ           */
         NULL,            /* ꤹ빽¤ΥեɤؤΥեå */
         OR_ALL,          /* ǥ쥯ƥ֤Υ               */
         TAKE1,           /* ǥ쥯ƥ֤ΰη             */
         "Set Message"    /*                                    */
    },
    { NULL }              /* ü */
};

static int simple_conf_handler(request_rec *r)
{
    simple_dir_config *conf;

    conf = ap_get_module_config(r->per_dir_config, &simple_conf_module);

    r->content_type = "text/html";      
    ap_send_http_header(r);
    if (!r->header_only)
        ap_rputs(conf->message, r);
    return OK;
}

/* Dispatch list of content handlers */
static const handler_rec simple_conf_handlers[] = { 
    { "simple_conf", simple_conf_handler }, 
    { NULL, NULL }
};

/* Dispatch list for API hooks */
module MODULE_VAR_EXPORT simple_conf_module = {
    STANDARD_MODULE_STUFF, 
    NULL,                  /* module initializer                  */
    create_per_dir_config, /* create per-dir    config structures */
    NULL,                  /* merge  per-dir    config structures */
    NULL,                  /* create per-server config structures */
    NULL,                  /* merge  per-server config structures */
    cmds,                  /* table of config file commands       */
    simple_conf_handlers,       /* [#8] MIME-typed-dispatched handlers */
    NULL,                  /* [#1] URI to filename translation    */
    NULL,                  /* [#4] validate user id from request  */
    NULL,                  /* [#5] check if the user is ok _here_ */
    NULL,                  /* [#3] check access by host address   */
    NULL,                  /* [#6] determine MIME type            */
    NULL,                  /* [#7] pre-run fixups                 */
    NULL,                  /* [#9] log a transaction              */
    NULL,                  /* [#2] header parser                  */
    NULL,                  /* child_init                          */
    NULL,                  /* child_exit                          */
    NULL                   /* [#0] post read-request              */
};

